package cn.iocoder.yudao.module.system.service.extra;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.module.system.controller.admin.extra.vo.OutingConfirmationFormPageReqVO;
import cn.iocoder.yudao.module.system.dal.dataobject.extra.ElderlyExtraOutingConfirmationFormDO;
import cn.iocoder.yudao.module.system.dal.mysql.extra.ElderlyExtraOutingConfirmationFormMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.system.enums.ErrorCodeConstants.ELDERLY_EXTRA_OUTING_CONFIRMATION_FORM_NOT_EXISTS;

/**
 * (附件)外出情况确认书 Service 实现
 *
 * @author 管理员
 */
@Service
@Slf4j
public class ElderlyExtraOutingConfirmationFormServiceImpl implements ElderlyExtraOutingConfirmationFormService {

    @Resource
    private ElderlyExtraOutingConfirmationFormMapper mapper;

    @Override
    public Long create(ElderlyExtraOutingConfirmationFormDO createReqVO) {
        mapper.insert(createReqVO);
        return createReqVO.getId();
    }

    @Override
    public void update(ElderlyExtraOutingConfirmationFormDO updateReqVO) {
        validateExists(updateReqVO.getId());
        mapper.updateById(updateReqVO);
    }

    @Override
    public void delete(Long id) {
        validateExists(id);
        mapper.deleteById(id);
    }

    @Override
    public PageResult<ElderlyExtraOutingConfirmationFormDO> findPage(OutingConfirmationFormPageReqVO reqVO) {
        return mapper.selectPage(reqVO);
    }

    @Override
    public ElderlyExtraOutingConfirmationFormDO getDetail(Long id) {
        return validateExists(id);
    }

    @Override
    public List<ElderlyExtraOutingConfirmationFormDO> getListByElderId(Long elderId) {
        return mapper.selectList(
                new LambdaQueryWrapperX<ElderlyExtraOutingConfirmationFormDO>()
                        .eqIfPresent(ElderlyExtraOutingConfirmationFormDO::getElderId, elderId)
                        .orderByDesc(ElderlyExtraOutingConfirmationFormDO::getCreateTime)
        );
    }

    private ElderlyExtraOutingConfirmationFormDO validateExists(Long id) {
        ElderlyExtraOutingConfirmationFormDO record = mapper.selectById(id);
        if (record == null) {
            throw exception(ELDERLY_EXTRA_OUTING_CONFIRMATION_FORM_NOT_EXISTS);
        }
        return record;
    }

}
